# Author: Logan Tucker
# Date: 11.17.2021
# Purpose: Preform a Breadth-first search on the graph with back chaining


from collections import deque


# Input: start, goal (vertices)
# Output path from start to goal
# Information stored as: frontier in a queue and back pointers in a dictionary
def bfs(start, goal):
    frontier = deque()
    bkp_d = {}

    frontier.append(start)
    bkp_d[start] = None

    while len(frontier) > 0:
        v = frontier.popleft()

        for u in v.adjlist:
            if u not in bkp_d:
                frontier.append(u)
                bkp_d[u] = v

        if goal in bkp_d:
            break

    path = []
    x = goal

    while x is not None:
        path.append(x)
        x = bkp_d[x]

    return path

